#define BMESG_SUCCESS 0
#define BMESG_NO_DATA 1
#define BMESG_NOT_ENOUGH_SPACE 2
#define BMESG_WOULD_NEVER_FIT 3
#define BMESG_NOT_IMPLEMENTED 10

#define BUFFER_LENGTH 256   // must be multiple of 2

typedef struct circ_buff {
    unsigned char read_pos, write_pos;
    char buffer[BUFFER_LENGTH];
} Circ_buff;

unsigned char init_buffer( Circ_buff *buff );
unsigned char get_avail_space( Circ_buff *buff );
unsigned char read_char( Circ_buff *buff, char *data );
unsigned char write_char( Circ_buff *buff, char data );
unsigned char write_string( Circ_buff *buff, char *data, unsigned char len );


